#!/usr/bin/env python

# Replaces specific tile ids. Only modifies the game and front layers
# Author: Patiga
# License: AGPL-3.0-only

import twmap
import sys

map = twmap.Map(sys.argv[1])

# This dictionary can be edited to replace other tiles
ids = {
    1: 255, # Replaces hookable with the temporary id 255
    3: 1,   # Replaces unhookable with hookable
    255: 3, # Replaces the former hookable blocks (id 255) with unhookable
}
# Note that the replacements are done in this order!
# 1: 3, 3: 1 would result in all tiles with id 1 and 3 to end up with id 1

def replace(layer):
    tiles = layer.tiles
    id_view = tiles[:,:,0]
    for old, new in ids.items():
        id_view[id_view == old] = new
    layer.tiles = tiles

replace(map.game_layer())
if map.front_layer() is not None:
    replace(map.front_layer())
map.save(sys.argv[2])
